%define	debug_package		%{nil}

%if 0%{?centos} == 7
%define python3_pkgversion 36
%endif

%define VirtualEnvironment      %{_prefix}/local/lib/PythonVirtualEnvironments/%{name}-%{version}

Name:		wdpassport-utils
Version:	0.2
Release:	1%{?dist}
Summary:	Lock, Unlock, and Manage Western Digital My Passport Drives
Group:		Applications
License:	GPL3
Source0:	%{name}-%{version}.tar.gz
URL:		https://github.com/0-duke/wdpassport-utils
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Requires:	python%{python3_pkgversion}

%description
A Linux command-line utility to lock, unlock, and manage the hardware encryption functionality
of Western Digital My Passport external drives. Written in Python 3.

WD My Passport drives support hardware encryption. New drives arrive in a passwordless state ---
they can be used without locking or unlocking. After a password is set, drives become locked
when they are unplugged and must be unlocked when they are plugged in to mount the volume and
see its content.

This utlity can:

* Show drive status.
* Set and change the drive's password.
* Unlock an encrypted drive, given the password.
* Reset the drive in case of a lost password.
* Passwords given on the command line are converted into binary password data in a mechanism
  intended to be compatible with WD's unlock software that is used in Microsoft Windows.

This tool was originally written by 0-duke in 2015 based on reverse engineering research by
DanLukes and an implementation by DanLukes and KenMacD. crypto-universe converted this project
and the underlying SCSI interface library py_sg to Python 3. JoshData updated the library to
work with the latest WD My Passport device.

%prep
%setup

%build
echo Nothing to build

%post
echo Building the Python Virtual Environment for WDPassport-Utils. This will take a while. > /proc/$PPID/fd/1
mkdir -p %{VirtualEnvironment}
%if 0%{?fedora} 
virtualenv -q %{VirtualEnvironment}
%else
virtualenv-3 -q %{VirtualEnvironment}
%endif
. %{VirtualEnvironment}/bin/activate
cp /dev/null /tmp/%{name}-%{version}-install.log
for p in pip %{VirtualEnvironment}/%{name}
do
        echo -n Installing $p in the virtual environment ... > /proc/$PPID/fd/1
        pip3 install --upgrade "$p" >> /tmp/%{name}-%{version}-install.log 2>&1
        echo " Done" > /proc/$PPID/fd/1
done
chmod 755 %{VirtualEnvironment}/bin/%{name}.py 
echo Done building the Python Virtual Environment for WDPassport-Utils. > /proc/$PPID/fd/1

%postun
rm -rf %{VirtualEnvironment}

%install
%__install -d %{buildroot}%{VirtualEnvironment}/%{name}
cp -p * %{buildroot}%{VirtualEnvironment}/%{name}
%__install -d %{buildroot}%{_bindir}
cat > %{buildroot}%{_bindir}/%{name} << 'EOF'
#!/bin/sh
. %{VirtualEnvironment}/bin/activate
exec sudo %{VirtualEnvironment}/bin/%{name}.py "$@"
EOF
cd %{buildroot}%{_bindir}
ln -s %{name} %{name}.py

%clean
rm -rf ${RPM_BUILD_ROOT}

%files
%doc LICENSE README.md
%defattr(644,root,root,755)
%{VirtualEnvironment}
%attr(755, root, root)	%{_bindir}/%{name}
%attr(755, root, root)	%{_bindir}/%{name}.py

%changelog
* Thu Sep  9 2021 Lawrence R. Rogers <lrr@@cert.org> - 0.2-1
- Release 0.2-1
	Initial release
	See https://github.com/0-duke/wdpassport-utils
